require_relative './ty_function'

module TypedRb
  module Types
    class TyDynamic < TyObject
      def compatible?(_other_type, _relation = :lt)
        true
      end

      def dynamic?
        true
      end
    end

    class TyDynamicFunction < TyFunction
      def initialize(klass, message, with_block = true, node = nil)
        super([], TyDynamic.new(Object, node), nil, node)
        @klass = klass
        @message = message
        @arity = Float::INFINITY
        @block_type = TyDynamicFunction.new(Proc, :cal, false) if with_block
      end

      def dynamic?
        true
      end

      def arg_compatible?(_)
        true
      end

      def check_args_application; end

      def compatible?(_other_type, _relation = :lt)
        true
      end
    end
  end
end
